diff --git a/test/csuite/compile_config/main.c b/test/csuite/compile_config/main.c
new file mode 100644
index 000000000..e66a6c0b7
--- /dev/null
+++ b/test/csuite/compile_config/main.c
@@ -0,0 +1,219 @@
+/*-
+ * Public Domain 2014-present MongoDB, Inc.
+ * Public Domain 2008-2014 WiredTiger, Inc.
+ *
+ * This is free and unencumbered software released into the public domain.
+ *
+ * Anyone is free to copy, modify, publish, use, compile, sell, or
+ * distribute this software, either in source code form or as a compiled
+ * binary, for any purpose, commercial or non-commercial, and by any
+ * means.
+ *
+ * In jurisdictions that recognize copyright laws, the author or authors
+ * of this software dedicate any and all copyright interest in the
+ * software to the public domain. We make this dedication for the benefit
+ * of the public at large and to the detriment of our heirs and
+ * successors. We intend this dedication to be an overt act of
+ * relinquishment in perpetuity of all present and future rights to this
+ * software under copyright law.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+ * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+ * IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR
+ * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
+ * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ */
+#include "test_util.h"
+
+#include <signal.h>
+
+/*
+ * compile_check --
+ *     Run tests for the compiled configuration strings.
+ */
+static void
+compile_check(TEST_OPTS *opts, bool first, bool compile)
+{
+    WT_CONNECTION *conn;
+    WT_CURSOR *c;
+    WT_SESSION *session;
+    time_t start, end;
+    const char *compiled;
+    const char *compiled_conn1;
+    const char *compiled_conn2;
+    const char *compiled_dump;
+    const char *compiled_dump_variable;
+    const char *compiled_multi;
+    const char *compiled_overwrite;
+    const char *compiled_ts;
+
+    const char *uri = "table:foo";
+    const char *uri2 = "table:bar";
+
+    testutil_check(wiredtiger_open(opts->home, NULL, "create", &opts->conn));
+    conn = opts->conn;
+
+    if (compile)
+        testutil_check(
+          conn->compile_configuration(conn, "WT_SESSION.open_cursor", "dump=hex", &compiled_dump));
+    else
+        compiled_dump = "dump=hex";
+
+    if (compile)
+        testutil_check(conn->compile_configuration(
+          conn, "WT_SESSION.open_cursor", "dump=%s", &compiled_dump_variable));
+    else
+        compiled_dump_variable = NULL;
+    if (compile)
+        testutil_check(conn->compile_configuration(
+          conn, "WT_SESSION.open_cursor", "overwrite=false", &compiled_overwrite));
+    else
+        compiled_overwrite = "overwrite=false";
+
+    testutil_check(conn->open_session(conn, NULL, NULL, &session));
+    if (first) {
+        testutil_check(session->create(session, uri, "key_format=S,value_format=S"));
+        testutil_check(session->create(session, uri2, "key_format=S,value_format=S"));
+    }
+    testutil_check(session->open_cursor(session, uri, NULL, compiled_dump, &c));
+    testutil_assert((c->flags & WT_CURSTD_DUMP_HEX) != 0);
+    testutil_assert((c->flags & WT_CURSTD_OVERWRITE) != 0);
+    c->close(c);
+
+    testutil_check(session->open_cursor(session, uri, NULL, compiled_overwrite, &c));
+    testutil_assert((c->flags & WT_CURSTD_DUMP_HEX) == 0);
+    testutil_assert((c->flags & WT_CURSTD_OVERWRITE) == 0);
+    c->close(c);
+
+    if (compile)
+        testutil_check(
+          session->bind_configuration(session, compiled_dump_variable, &compiled, "json"));
+    else
+        compiled = "dump=json";
+    testutil_check(session->open_cursor(session, uri, NULL, compiled, &c));
+    testutil_assert((c->flags & WT_CURSTD_DUMP_HEX) == 0);
+    testutil_assert((c->flags & WT_CURSTD_DUMP_JSON) != 0);
+    testutil_assert((c->flags & WT_CURSTD_OVERWRITE) != 0);
+    c->close(c);
+
+    if (compile)
+        testutil_check(
+          session->bind_configuration(session, compiled_dump_variable, &compiled, "hex"));
+    else
+        compiled = "dump=hex";
+
+    testutil_check(session->open_cursor(session, uri, NULL, compiled, &c));
+    testutil_assert((c->flags & WT_CURSTD_DUMP_HEX) != 0);
+    testutil_assert((c->flags & WT_CURSTD_DUMP_JSON) == 0);
+    testutil_assert((c->flags & WT_CURSTD_OVERWRITE) != 0);
+    c->close(c);
+
+    compiled_multi = "raw=1,overwrite=0"; /* TODO: add "debug=(release_evict)" */
+    if (compile)
+        testutil_check(conn->compile_configuration(
+          conn, "WT_SESSION.open_cursor", compiled_multi, &compiled_multi));
+    testutil_check(session->open_cursor(session, uri2, NULL, compiled_multi, &c));
+    // TODO:
+    // testutil_assert((c->flags & WT_CURSTD_OVERWRITE) == 0);
+    // testutil_assert((c->flags & WT_CURSTD_RAW) == 1);
+    c->close(c);
+#define N_ITERATIONS_CURSOR_MULTI 5000000      // 5000000
+#define N_ITERATIONS_CURSOR_OVERWRITE 20000000 // 20000000
+#define N_ITERATIONS_TS 30000000               // 30000000
+#define N_ITERATIONS_RECONFIGURE 10000         // 10000
+    if (true) {
+        time(&start);
+        for (int i = 0; i < N_ITERATIONS_CURSOR_MULTI; i++) {
+            testutil_check(session->open_cursor(session, uri2, NULL, compiled_multi, &c));
+            c->close(c);
+            // if (i % 100000 == 0)
+            //    fprintf(stderr, " %d\n", i);
+        }
+        time(&end);
+        fprintf(stderr, "OPEN_CURSOR MULTI RUN FROM: %s TO ", ctime(&start));
+        fprintf(stderr, "%s: %d secs\n", ctime(&end), (int)(end - start));
+    }
+
+    if (true) {
+        time(&start);
+        for (int i = 0; i < N_ITERATIONS_CURSOR_OVERWRITE; i++) {
+            testutil_check(session->open_cursor(session, uri2, NULL, compiled_overwrite, &c));
+            c->close(c);
+            // if (i % 100000 == 0)
+            //    fprintf(stderr, " %d\n", i);
+        }
+        time(&end);
+        fprintf(stderr, "OPEN_CURSOR RUN OVERWRITE FROM: %s TO ", ctime(&start));
+        fprintf(stderr, "%s: %d secs\n", ctime(&end), (int)(end - start));
+    }
+
+    compiled_conn1 = "eviction_target=80,eviction_trigger=95";
+    compiled_conn2 = "eviction_target=81,eviction_trigger=96";
+    if (compile) {
+        testutil_check(conn->compile_configuration(
+          conn, "WT_CONNECTION.reconfigure", compiled_conn1, &compiled_conn1));
+        testutil_check(conn->compile_configuration(
+          conn, "WT_CONNECTION.reconfigure", compiled_conn2, &compiled_conn2));
+    }
+    if (true) {
+        time(&start);
+        for (int i = 0; i < N_ITERATIONS_RECONFIGURE; i++) {
+            testutil_check(conn->reconfigure(conn, compiled_conn1));
+            testutil_check(conn->reconfigure(conn, compiled_conn2));
+            if (i % 1000 == 0)
+                fprintf(stderr, " %d\n", i);
+        }
+        time(&end);
+        fprintf(stderr, "RECONFIGURE RUN FROM: %s TO ", ctime(&start));
+        fprintf(stderr, "%s: %d secs\n", ctime(&end), (int)(end - start));
+    }
+
+    if (true) {
+        if (compile)
+            testutil_check(conn->compile_configuration(conn, "WT_SESSION.timestamp_transaction",
+              "commit_timestamp=%d,durable_timestamp=%d", &compiled_ts));
+        else
+            compiled_ts = "commit_timestamp=1000,durable_timestamp=1000";
+
+        testutil_check(session->begin_transaction(session, NULL));
+        testutil_check(session->prepare_transaction(session, "prepare_timestamp=500"));
+        time(&start);
+        for (int i = 0; i < N_ITERATIONS_TS; i++) {
+            const char *bound;
+            if (compile)
+                testutil_check(
+                  session->bind_configuration(session, compiled_ts, &bound, 1001, 1001));
+            else
+                bound = compiled_ts;
+            testutil_check(session->timestamp_transaction(session, bound));
+        }
+        time(&end);
+        fprintf(stderr, "TIMESTAMP_TXN RUN FROM: %s TO ", ctime(&start));
+        fprintf(stderr, "%s: %d secs\n", ctime(&end), (int)(end - start));
+
+        testutil_check(session->rollback_transaction(session, NULL));
+    }
+
+    testutil_check(conn->close(conn, NULL));
+}
+
+/*
+ * main --
+ *     Set up the test for compiled configuration strings.
+ */
+int
+main(int argc, char *argv[])
+{
+    TEST_OPTS *opts, _opts;
+    opts = &_opts;
+    memset(opts, 0, sizeof(*opts));
+    testutil_check(testutil_parse_opts(argc, argv, opts));
+    testutil_make_work_dir(opts->home);
+
+    compile_check(opts, true, false);
+    compile_check(opts, false, true);
+
+    return (EXIT_SUCCESS);
+}
